trap command


 
Thread Tools Search this Thread
Top Forums UNIX for Advanced & Expert Users trap command
# 1  
Old 06-20-2011
trap command

Hello experts!

I need to know the use of trap command please

In one of our program we have
Code:
trap "rm -f temp1 ; exit 1" 1 2 15 0

and program always exit with 1

there is a rm -f temp1 as well at the end of the program

as

Code:
rm -f temp1
exit 0

when I test a probram with set -x
it gives

Code:
rm -f temp1
exit 0
rm -f
exit 1

what could be the use of trap in this case please?

Thanks and Regards,
Ram.
# 2  
Old 06-20-2011
The trap is there so that, if it dies unexpectedly from any of the signals 1, 2, 15, or 0(a special signal number that just means exit), the file will still be deleted.

As for why it's not working, without seeing the code I can't even guess.
# 3  
Old 06-23-2011
Quote:
trap "rm -f temp1 ; exit 1" 1 2 15 0
This would probably better as:
Code:
trap "rm -f temp1 ; exit 1" 1 2 3 15

As described above, the trap on signal "0" is being executed on normal exit from the script after the last two lines of the script have been executed.
I'd include signal "3" (intr) in the list to cover those times when you type the interrupt sequence from the keyboard (usually but not always ctrl/c).
# 4  
Old 06-24-2011
more info

In your research on the trap command, note that you can use the kill command to send a signal to a program, as well as enter various Ctrl characters typed at the keyboard which send a signal too (which you can trap as needed).

Ask the google about traps and signals for more info.

Gary
# 5  
Old 06-24-2011
You might want to change the exit 1 in the trap to just exit. This allows the exit code used when the trap was invoked to pass through. Thus if a script aborts with an exit 2 the exit code available to the parent process will be 2. More importantly, if the script exits with a zero (exit 0) that zero (success) is made available to the parent, and the desired cleanup is done.

Code:
trap "rm -f tmp-file; exit" EXIT 1 2 3 15

This is certainly available with Kshell; I assume bash has implemented it as well, but I cannot say.
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Trap command not working

Hi Folks - For some reason, my trap command is not working. It's placed just prior to a normal exit: #:: ------------------------------------------------------------------------ #::-- Script Name: LCM_Backup.sh #:: #::-- Description: This script leverages Utility.sh to perform LCM... (16 Replies)
Discussion started by: SIMMS7400
16 Replies

2. Homework & Coursework Questions

VM trap may work differently than a pure install trap.

Use and complete the template provided. The entire template must be completed. If you don't, your post may be deleted! 1. The problem statement, all variables and given/known data: That is the last reply I received from my instructor, and I'm looking for some alternatives. When using... (2 Replies)
Discussion started by: newuser45
2 Replies

3. Shell Programming and Scripting

trap command

dear all; I can't under stand what does "trap" command do: for example see below: trap "echo; echo no interrupts >&2; sleep 3" 2 3 15 Plz , can any body explain the action of this command? BR (3 Replies)
Discussion started by: ahmad.diab
3 Replies

4. UNIX for Dummies Questions & Answers

trap command

I'm learning about the trap command from my bash book. I tried out the little script they gave: trap "echo 'You hit control-C!' " INT while true; do sleep 60 done But when I type control-c, the script just stops and the message is not displayed. I checked stty all and saw that control-c... (11 Replies)
Discussion started by: Straitsfan
11 Replies

5. Shell Programming and Scripting

Cntl+z Trap is not detecting ??? Help required to add a trap detection ???

Hi folks, I have tried to add some trap detection in the below script....this script is used to monitor database activities...in a rather awkward way :rolleyes:.... The idea behind adding trap is that....this script creates lots of temporary files in the running folder to store the count... (1 Reply)
Discussion started by: frozensmilz
1 Replies

6. Shell Programming and Scripting

Use of TRAP Command

Hi, I would like to know the use of TRAP command. I am very new to the UNIX environment. I have just started learning the basic. So please teach me in a very simple way to understand. Also i would like to know the use of following command: trap 'dialog --msgbox "Script Aborted1" 6 50 ;... (2 Replies)
Discussion started by: Deepakh
2 Replies

7. Programming

trap command in Unix

Could anybody tell me what the trap command does and how it performs the action it does. I had read the trap manual page but it is too concise that nothing is clear about it. Please tell how it works. (1 Reply)
Discussion started by: mobile01
1 Replies

8. UNIX for Dummies Questions & Answers

trap command

Dear All could you please explain me what does the trap command do and how I can write a program which can work as a trap command(in C Language). (1 Reply)
Discussion started by: mobile01
1 Replies

9. UNIX for Dummies Questions & Answers

trap command

i have the following script that displays the current time until the user presses CTR + c.... but it does not work properly.... Something is not right with the trap command... Help plz... :confused: # script to continuously display current time. # if script is terminated trap signal... (3 Replies)
Discussion started by: onlyc
3 Replies

10. Shell Programming and Scripting

Using TRAP command

I'm using the trap command to capture any signals received whilst my script is running. How's the best way of writing the signal and any other error messages to a file/error log' without having to type '2>$1' on the command line after the script name? Cheers (3 Replies)
Discussion started by: dbrundrett
3 Replies
Login or Register to Ask a Question